/* RAW socket utility routine:
 * 
 * Write out an IP header.
 * shadows@whitefang.com
 * Thamer Al-Herbish
 */

#include <windows.h>
#include "types.h"
#include "ip.h"

#if !defined(HAVE_INCKSUM)
#include "checksum.h"
#endif

#if !defined(IPVERSION)
#define IPVERSION 4  /* Incase some system does not have this definition. */
#endif               /* We'll always be using 4 as the version anyway. */


#define DEFAULT_TTL 60  /* Just hard code the ttl in the ip header.*/

void ip_gen(char *packet,unsigned char protocol,struct in_addr saddr,
	    struct in_addr daddr,unsigned short length, LPWORD pid)
{
  struct iphdr *iphdr;

  iphdr = (struct iphdr *)packet;
  ZeroMemory((char *)iphdr, sizeof(struct iphdr));
  
  iphdr->ihl = 5;
  iphdr->version = IPVERSION;
    
//#ifdef IP_LEN_HORDER
  iphdr->tot_len = length;
//#else
//  iphdr->tot_len = htons(length);
//#endif /* IP_LEN_HORDER */
  
  iphdr->id = htons((*pid)++);
//  iphdr->id = htons(getpid());
  iphdr->ttl = DEFAULT_TTL;
  iphdr->protocol = protocol;

  iphdr->saddr = saddr.s_addr;
  iphdr->daddr = daddr.s_addr;

  iphdr->check = (unsigned short)in_cksum((unsigned short *)iphdr,
					  sizeof(struct iphdr));
  return;
}
