/* Transport header checksum
 * for TCP and UDP
 * shadows@whitefang.com
 */

#include <windows.h>
#include "types.h"

#include "ip.h"
#include "udp.h"

#if !defined(HAVE_INCKSUM)
#include "checksum.h"
#endif

struct psuedohdr  {
  struct in_addr source_address;
  struct in_addr dest_address;
  unsigned char place_holder;
  unsigned char protocol;
  unsigned short length;
} psuedohdr;

unsigned short trans_check(unsigned char proto,
			   char *packet,
			   int length,
			   struct in_addr source_address,
			   struct in_addr dest_address)
{
  char *psuedo_packet;
  unsigned short answer;
  
  psuedohdr.protocol = proto;
  psuedohdr.length = htons((WORD) length);
  psuedohdr.place_holder = 0;

  psuedohdr.source_address = source_address;
  psuedohdr.dest_address = dest_address;
  
  if((psuedo_packet = GlobalAlloc(GMEM_FIXED, sizeof(psuedohdr) + length)) == NULL)
	return 0;
  
  CopyMemory(psuedo_packet,&psuedohdr,sizeof(psuedohdr));
  CopyMemory((psuedo_packet + sizeof(psuedohdr)),
	 packet,length);
  
  answer = (unsigned short)in_cksum((unsigned short *)psuedo_packet,
				    (length + sizeof(psuedohdr)));
  GlobalFree(GlobalHandle(psuedo_packet));
  return answer;
}
